package developpez.table;


import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;


public class TestTableCellulesFusionables extends JFrame {

    private static final long serialVersionUID = 1L;

    TestTableCellulesFusionables() {

        MyTableModel model = new MyTableModel(10,6);
        final DefaultCellAttribute cellAtt =model.getCellAttribute();
        final TableCellulesFusionables table = new TableCellulesFusionables( model );
        JScrollPane scroll = new JScrollPane( table );

        JButton btnFusionner   = new JButton("Fusionner");
        btnFusionner.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                int[] columns = table.getSelectedColumns();
                int[] rows    = table.getSelectedRows();
                cellAtt.combine(rows,columns);
                table.clearSelection();
                table.revalidate();
                table.repaint();
            }
        });
        
        
        JButton btnSeparer = new JButton("Sparer");
        btnSeparer.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                int column = table.getSelectedColumn();
                int row    = table.getSelectedRow();
                cellAtt.split(row,column);
                table.clearSelection();
                table.revalidate();
                table.repaint();
            }
        });
        
        JPanel p_buttons = new JPanel();
        p_buttons.setLayout(new GridLayout(2,1));
        p_buttons.add(btnFusionner);
        p_buttons.add(btnSeparer);

        Box box = new Box(BoxLayout.X_AXIS);
        box.add(scroll);
        box.add(new JSeparator(SwingConstants.HORIZONTAL));
        box.add(p_buttons);
        getContentPane().add( box );
        setSize( 400, 200 );
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
    }

    public static void main(String[] args) {
        new TestTableCellulesFusionables();
    }
}

